unit dxclockfrm;

interface

uses
  {$IFDEF FPC}
  LCLProc, LCLIntf,
  {$ENDIF}
  {$ifdef win32}
  {$IFNDEF FPC}Windows, {$ELSE}LResources, {$ENDIF}
  {$endif}
  SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, dx_scene, dx_objects, dx_utils, ExtCtrls, Math, dx_ani,
  dx_vgcore, dx_vglayer;

type
  TfrmDXClock = class(TForm)
    dxScene1: TdxScene;
    Root1: TdxVisualObject;
    Face: TdxDummy;
    Light1: TdxLight;
    Camera1: TdxCamera;
    edge: TdxDummy;
    Dummy3: TdxDummy;
    Dummy4: TdxDummy;
    arrowH: TdxDummy;
    arrowHour: TdxDummy;
    arrowMin: TdxDummy;
    Dummy5: TdxDummy;
    arrowSec: TdxDummy;
    Dummy6: TdxDummy;
    Timer1: TTimer;
    dayText: TdxText3D;
    cameraz: TdxDummy;
    camerax: TdxDummy;
    Back: TdxDummy;
    Clock: TdxDummy;
    Text3D1: TdxText3D;
    Sphere1: TdxSphere;
    ColorAnimation1: TdxColorAnimation;
    ColorAnimation2: TdxColorAnimation;
    Text3D2: TdxText3D;
    GUIObjectLayer1: TdxGUIObjectLayer;
    Root2: TvxLayout;
    Rectangle1: TvxRectangle;
    HudTrackBar1: TvxHudTrackBar;
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure dxScene1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure dxScene1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure dxScene1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure dxScene1MouseWheel(Sender: TObject; Shift: TShiftState;
      WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
    procedure Sphere1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Single; rayPos, rayDir: TdxVector);
    procedure HudTrackBar1Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Down: TPoint;
  end;

var
  frmDXClock: TfrmDXClock;

implementation

{$R *.dfm}

procedure TfrmDXClock.Timer1Timer(Sender: TObject);
var
  H, M, S, MS: word;
begin
  { set times }
  DecodeTime(Time, H, M, S, MS);
  arrowSec.RotateAngle.Z := -90 + 360 * (S / 60) + (6 * (MS / 1000));
  arrowMin.RotateAngle.Z := -90 + 360 * (M / 60);
  arrowHour.RotateAngle.Z := -90 + 360 * ((H mod 12) / 12);
  DecodeDate(Date, H, M, S);
  dayText.Text := IntToStr(S);
//  Text3D1.Text := IntToStr(Round(dxScene1.Fps));
end;

procedure TfrmDXClock.FormCreate(Sender: TObject);
begin
  Timer1Timer(Self);
end;

procedure TfrmDXClock.dxScene1MouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  if ssRight in Shift then
  begin
    { rotate Z }
    CameraZ.RotateAngle.Z := CameraZ.RotateAngle.Z + ((X - Down.X) * 0.3);
    { rotate X }
    CameraX.RotateAngle.X := CameraX.RotateAngle.X + ((Y - Down.Y) * 0.3);
    Down := Point(X, Y);
  end;
end;

procedure TfrmDXClock.dxScene1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbRight then
  begin
    Down := Point(X, Y);
    SetCapture(dxScene1.Handle);
  end;
end;

procedure TfrmDXClock.dxScene1MouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbRight then
    ReleaseCapture;
end;

procedure TfrmDXClock.dxScene1MouseWheel(Sender: TObject;
  Shift: TShiftState; WheelDelta: Integer; MousePos: TPoint;
  var Handled: Boolean);
var
  scale: single;
begin
  scale := Clock.Scale.X + (1 / (WheelDelta * 30)) * 3;
  if scale < 0.3 then scale := 0.3;
  if scale > 1 then scale := 1;
  Clock.Scale.Point := dxPoint(scale, scale, scale);
end;

procedure TfrmDXClock.Sphere1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Single; rayPos, rayDir: TdxVector);
begin
  Close;
end;

procedure TfrmDXClock.HudTrackBar1Change(Sender: TObject);
begin
  Clock.Opacity := HudTrackBar1.Value;
end;

end.
